package edu.umich.languageid;

import java.util.ArrayList;
import java.util.Collection;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;

import cc.mallet.fst.CRF;
import cc.mallet.fst.semi_supervised.CRFTrainerByGE;
import cc.mallet.fst.semi_supervised.constraints.GEConstraint;
import cc.mallet.types.FeatureVectorSequence;
import cc.mallet.types.Instance;
import cc.mallet.types.InstanceList;
import cc.mallet.types.Sequence;
import edu.umich.languageid.hmm.HiddenMarkovModel;

public class EMHMM
{
	protected Collection<String> labels;
	
	public EMHMM(Collection<String> labels)
	{
		this.labels = labels;
	}
	
	public void printClassification(InstanceList trainingData, InstanceList testingData)
	{
		Classifier<Instance> topLevelClassifier = new MaxEntWrapper(trainingData);
		HiddenMarkovModel<Instance> hmm = new HiddenMarkovModel<Instance>(labels, topLevelClassifier);
		List<LabeledInstance<Instance>> hmmLabels = null;
		for(int i=0; i<20; i++)
		{
			hmmLabels = hmm.labelSequence(testingData);
			
			TransitionProbabilityEstimator<Instance> tpe = new TransitionProbabilityEstimator<Instance>();
			Map<String, Map<String, Double>> transitionProbabilities = tpe.estimateTransitionProbabilities(hmmLabels, new HashSet<String>(labels));
			hmm.updateTransitionProbabilities(transitionProbabilities);
			
			Classifier<Instance> newClassifier = topLevelClassifier.createUpdatedClassifier(hmmLabels);
			hmm.updateClassifier(newClassifier);
		}

		String previousClass = "";
		for(LabeledInstance<Instance> inst : hmmLabels)
		{
			String bestClass = inst.getLabel();
			if(bestClass.equals(previousClass))
			{
				System.out.print(" " + (String)inst.getValue().getName());
			}
			else
			{
				System.out.println();
				System.out.print("[[" + bestClass + "]] " + (String)inst.getValue().getName());
			}
			previousClass = bestClass;
		}
	}
}
