package edu.umich.languageid;

import java.util.ArrayList;

import cc.mallet.classify.MaxEnt;
import cc.mallet.classify.MaxEntGETrainer;
import cc.mallet.classify.Trial;
import cc.mallet.classify.constraints.ge.MaxEntGEConstraint;
import cc.mallet.types.Instance;
import cc.mallet.types.InstanceList;

public class MaxEntwithGE
{
	public double maxEntWithGEAccuracy(InstanceList testingDataNoLabels, InstanceList testingData, ArrayList<MaxEntGEConstraint> constraints)
	{
		MaxEntGETrainer trainer = new MaxEntGETrainer(constraints);
		trainer.train(testingDataNoLabels);
		
		MaxEnt classifier = trainer.getClassifier();
		Trial test = new Trial(classifier, testingData);
		return test.getAccuracy();
	}
	
	public void printClassification(InstanceList testingDataNoLabels, InstanceList testingData, ArrayList<MaxEntGEConstraint> constraints)
	{
		MaxEntGETrainer trainer = new MaxEntGETrainer(constraints);
		trainer.train(testingDataNoLabels);
		
		MaxEnt classifier = trainer.getClassifier();
		String previousClass = "";
		for(Instance i : testingData)
		{
			String bestClass = classifier.classify(i).getLabeling().getBestLabel().toString();
			if(bestClass.equals(previousClass))
			{
				System.out.print(" " + i.getName());
			}
			else
			{
				System.out.println();
				System.out.print("[[" + bestClass + "]] " + i.getName());
			}
			previousClass = bestClass;
		}
	}
}
