package edu.umich.languageid.hmm;

public class DefaultViterbiTransition<T> implements ViterbiTransition<T>
{
	ViterbiNode<T> previousNode;
	double transitionProbability;
	
	public DefaultViterbiTransition(ViterbiNode<T> previousNode, double transitionProbability)
	{
		this.previousNode = previousNode;
		this.transitionProbability = transitionProbability;
	}

	public ViterbiNode<T> getPreviousNode()
	{
		return previousNode;
	}

	public double getTransitionProbability()
	{
		return transitionProbability;
	}
	
	public double getScore()
	{
		return previousNode.getScore() + Math.log(transitionProbability); // use logs of scores to keep them from getting too small
	}
}
