package edu.umich.languageid.hmm;

import java.util.List;

public interface ViterbiNode<T>
{
	public void addPreviousNode(ViterbiNode<T> previousNode, double transitionProb);
	
	public void addPreviousNode(ViterbiTransition<T> transition);
	
	public void addPreviousNodes(List<ViterbiTransition<T>> transitions);
	
	public void setEmissionProbability(double emissionProbability);
	
	public double getScore();	
	
	public ViterbiNode<T> getBestPreviousState();
	
	public double getPreviousNodeConfidence();
	
	public T getValue();
	
	public String getLabel();
	
	public boolean isTerminal();
}
